import 'package:shared_preferences/shared_preferences.dart';

abstract class LocaleStorage {
  const LocaleStorage();
  Future<dynamic> read(String key);
  Future<bool?> write<T>(String key, T value);
}

class SharedPreferencesStorage implements LocaleStorage {
  @override
  Future<bool?> write<T>(String key, T value) async {
    final _preferences = await SharedPreferences.getInstance();
    switch (value.runtimeType) {
      case int:
        return _preferences.setInt(key, value as int);
      case bool:
        return _preferences.setBool(key, value as bool);
      case double:
        return _preferences.setDouble(key, value as double);
      case String:
        return _preferences.setString(key, value as String);
      default:
        return null;
    }
  }

  @override
  Future<dynamic> read(String key) async {
    final _preferences = await SharedPreferences.getInstance();
    return _preferences.get(key);
  }
}
